/* I N C L U D E S **********************************************************/
#include <p18cxxx.h>
#include <string.h>

#include "system\typedefs.h"
#include "io_cfg.h"
#include "screenuser.h"
#include "..\system\display\sed1565.h"             // I/O pin mapping
#include "..\system\EEPROM\eeprom.h"

/* V A R I A B L E S ********************************************************/
#pragma udata
char indicators[7];

/* F U N C T I O N S ********************************************************/

/** Test the screen functions **/
void SED1565ScreenTest(void)
{
	unsigned char temp, col, x_pos, y_pos, data, length;
	unsigned char retVal, i, j;
 /* Polar co-ordinates are decimal values so
  *  page boundaries are set at the following
  *  x_pos values
  */

// draw horizontal line
 x_pos = 56;
 y_pos = 0;
 length = 128;
		
	drawlineHorizontal(x_pos, y_pos, length);

  // draw vertical lines
 x_pos = 17;
 y_pos = 20;
 length = 32;

   //debug = TRUE;
	j=0;
	for(i=0;i<80;i+=10)
	  {
	   drawlineVertical(x_pos, (y_pos+i)+4, length);
	   indicators[j] = (y_pos+i)+4; 
		//if(i%10 == 0)
		//{
		 //indicators[j] = (y_pos+i)+4;
		  WriteToEEPROM(indicators[j], 0x90+j);	
		 j++;
		//}		  
	  }	

	drawIndicator(36, 20);

	SED1565ModeRead();
}

/** Switch on the display indicator **/
void drawIndicator(unsigned char x_pos, unsigned char y_pos)
{

	unsigned char address, addr;
    int i, j, length;

	j=0;

	 for(i=0;i<128;i++)
	  { 	   
	   if(indicators[j] == i)
		{
	     SED1565SetPixel(x_pos, i+1);
	     //SED1565SetPixel(x_pos, i+2);
		 SED1565SetPixel(x_pos, i+3);
		 j++;	
		} 
	  }

}
