/* I N C L U D E S **********************************************************/
#include <p18cxxx.h>
#include "GenericTypeDefs.h"
#include "../HardwareProfile - Baseboard4550.h"
#include "simbuck_cfg.h"             // I/O pin mapping
#include "sed1565.h"
#include "../system/eeprom/eeprom.h"
#include <string.h>

/* V A R I A B L E S ********************************************************/
#if defined(BATRON_DISPLAY)

/** PROBATRON logo **/
#pragma romdata logo = 0x100
far rom char logo[256] = {
0x00, 0x00, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE,  // page 0
0xCE, 0xCE, 0xFE, 0xFE, 0xFC, 0x78, 0x00, 0x00,
0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE,
0xFE, 0xFE, 0x7C, 0x38, 0x00, 0x00, 0xF0, 0xF8,
0xFC, 0x3E, 0x1E, 0x0E, 0x0E, 0x1E, 0x3E, 0xFC,
0xF8, 0xF0, 0x00, 0x00, 0xCE, 0xCE, 0xCE, 0xCE,
0xCE, 0xCE, 0xCE, 0xCE, 0xFE, 0xFE, 0x7C, 0x38,
0x00, 0x00, 0x80, 0xC0, 0xC0, 0xC8, 0xCC, 0xCE,
0xFC, 0xF8, 0xF0, 0xE0, 0xC0, 0x80, 0x00, 0x00,
0x0E, 0x0E, 0x0E, 0x0E, 0xFE, 0xFE, 0xFE, 0xFE,
0x0E, 0x0E, 0x0E, 0x0E, 0x00, 0x00, 0xCE, 0xCE,
0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xFE, 0xFE,
0x7C, 0x38, 0x00, 0x00, 0xF0, 0xF8, 0xFC, 0x3E,
0x1E, 0x0E, 0x0E, 0x1E, 0x3E, 0xFC, 0xF8, 0xF0,
0x00, 0x00, 0xCE, 0xCE, 0xCE, 0xC8, 0xC0, 0xC0,
0x80, 0x00, 0x00, 0xFE, 0xFE, 0xFE, 0x00, 0x00,  // end page 0
0x00, 0x00, 0x7F, 0x7F, 0x7F, 0x01, 0x01, 0x01,  // page 1
0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00,
0x7F, 0x7F, 0x7F, 0x01, 0x03, 0x07, 0x0F, 0x1F,
0x3D, 0x78, 0x70, 0x60, 0x00, 0x00, 0x0F, 0x1F,
0x3F, 0x7C, 0x78, 0x70, 0x70, 0x78, 0x7C, 0x3F,
0x1F, 0x0F, 0x00, 0x00, 0x7F, 0x7F, 0x7F, 0x73,
0x73, 0x73, 0x73, 0x73, 0x7F, 0x7F, 0x3F, 0x1E,
0x00, 0x00, 0x7F, 0x7F, 0x7F, 0x07, 0x03, 0x01,
0x01, 0x03, 0x07, 0x7F, 0x7F, 0x7F, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x7F, 0x7F, 0x7F, 0x7F,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x7F,
0x7F, 0x01, 0x03, 0x07, 0x0F, 0x1F, 0x3D, 0x78,
0x70, 0x60, 0x00, 0x00, 0x0F, 0x1F, 0x3F, 0x7C,
0x78, 0x70, 0x70, 0x78, 0x7C, 0x3F, 0x1F, 0x0F,
0x00, 0x00, 0x7F, 0x7F, 0x7F, 0x00, 0x01, 0x03,
0x07, 0x0F, 0x1E, 0x7F, 0x7F, 0x7F, 0x00, 0x00  // end page 1
};


 
/* P R O T T Y P E S ********************************************************/
#pragma udata
char flags;
BOOL debug;


/* D E C L A R A T I O N S **************************************************/
#pragma code


/** Set the data lines as Output for writing **/
void SED1565ModeWrite(void)
{

// 	TRISAbits.TRISA3 = OUTPUT_PIN;			// DB3
//	TRISAbits.TRISA2 = OUTPUT_PIN;			// DB2
//	TRISAbits.TRISA1 = OUTPUT_PIN;			// DB1
//	TRISAbits.TRISA0 = OUTPUT_PIN;			// DB0

	// set PORTB pins
	TRISDbits.TRISD7 = OUTPUT_PIN;			// DB7
	TRISDbits.TRISD6 = OUTPUT_PIN;			// DB6
	TRISDbits.TRISD5 = OUTPUT_PIN;			// DB5
	TRISDbits.TRISD4 = OUTPUT_PIN;			// DB4

	TRISDbits.TRISD3 = OUTPUT_PIN;			// DB3
	TRISDbits.TRISD2 = OUTPUT_PIN;			// DB2
	TRISDbits.TRISD1 = OUTPUT_PIN;			// DB1
	TRISDbits.TRISD0 = OUTPUT_PIN;			// DB0

}


/** Set data lines as inputs for reading on single Port [PORTB] **/
void SED1565ModeRead(void)
{

  
//	TRISAbits.TRISA3 = INPUT_PIN;			// DB3
//	TRISAbits.TRISA2 = INPUT_PIN;			// DB2
//	TRISAbits.TRISA1 = INPUT_PIN;			// DB1
//	TRISAbits.TRISA0 = INPUT_PIN;			// DB0

	// set PORTB pins
	TRISDbits.TRISD7 = INPUT_PIN;			// DB7
	TRISDbits.TRISD6 = INPUT_PIN;			// DB6
	TRISDbits.TRISD5 = INPUT_PIN;			// DB5
	TRISDbits.TRISD4 = INPUT_PIN;			// DB4

	TRISDbits.TRISD3 = INPUT_PIN;			// DB3
	TRISDbits.TRISD2 = INPUT_PIN;			// DB2
	TRISDbits.TRISD1 = INPUT_PIN;			// DB1
	TRISDbits.TRISD0 = INPUT_PIN;			// DB0


}


/*unsigned char SED1565DataLines(unsigned char dataword)
{

  
  char temp = 0xFF;
  unsigned char hiNybble, loNybble, temp_A, temp_B;
  byte retval;
 
	if(debug){return -1;}

  hiNybble = dataword & 0xF0;
  loNybble = dataword & 0x0F;

  temp_A = PORTA & 0xF0;  // keep the upper nibble
  temp_A += loNybble;	  // add the lo nibble from dataword
  temp_B = PORTB & 0x0F;  // keep the lower nibble
  temp_B += hiNybble;     // add the hi nibble from dataword

  // D7:D4[RB7:RB4]
  temp &= (dataword & 0xF0);
  temp += (PORTB & 0x0F);
   
  retval = temp & 0xF0; 

  if(temp != temp_B)
	{
      WriteToEEPROM(temp, 0x10);
	  WriteToEEPROM(temp_B, 0x11);
	}

	PORTB = temp; 
    
  // D3:D0[RA3:RA0]
  temp = 0xFF;
  temp &= (dataword & 0x0F);
  temp += (PORTA & 0xF0);
  
  retval = retval + (temp & 0x0F);

  if(temp != temp_A)
	{
      WriteToEEPROM(temp, 0x00);
	  WriteToEEPROM(temp_A, 0x01);
	}

    PORTA = temp;
	
	return retval;

} */



/** Set the data lines as Output for writing on single port [PORTB] **/

unsigned char SED1565DataLines(unsigned char dataword)
{

	if(debug){return -1;}
  	 PORTD = dataword;

         Nop();Nop();
         Nop();Nop();
         Nop();Nop();
         Nop();Nop();
         Nop();Nop();

	return dataword;

}

void SED1565DefaultLines(void)
{
    // set the default line state
   A0_disable();
   RW_WR_disable();
   E_RD_disable();
   BATRON_CS_disable();

}

/** Initialise the display control registers **/

void SED1565Bootstrap_display(void)
{
    


	SED1565WriteCmd(DISPLAY_START_LINE_SET);
	SED1565WriteCmd(LCD_BIAS_SET);
	SED1565WriteCmd(ADC_SELECT_REVERSE);
	SED1565WriteCmd(COMMON_OUTPUT_MODE_NORMAL);
	SED1565WriteCmd(POWER_CONROL_MODE);
	SED1565WriteCmd(RESISTOR_RATIO);
//	SED1565WriteCmd(ELEC_VOL_MODE_SET);
//	SED1565WriteCmd(RESISTOR_RATIO);
	SED1565WriteCmd(DISPLAY_ON);
	SED1565WriteCmd(DISPLAY_REVERSE);
  
 	SED1565ClearScreen();
        drawImage();
// 	SED1565ScreenTest();
        SED1565WriteCmd(DISPLAY_ALL_POINTS_ON);
}


/** Re-Set the display hardware **/

void SED1565HardReset(void)
{
  int i;
  
  RES_enable();
  // hold low for minimum 0.5 usecs

  for(i=0;i<255;i++)
  {
   Nop();
  }

  RES_disable();

  SED1565DefaultLines();
  
}


/** Write a command to the Display hardware **/

unsigned char SED1565WriteCmd(char data)
{
  
  SED1565ModeWrite();
  SED1565DataLines(data);

  // A0=0;E=1;RD_WR=0;
  A0_enable();    	// 0
  BATRON_CS_enable();
  E_RD_disable();      // 1
  RW_WR_enable();	// 0

         Nop();Nop();
         Nop();Nop();
         Nop();Nop();
         Nop();Nop();
         Nop();Nop();

  
  RW_WR_disable();
  E_RD_disable();
  BATRON_CS_disable();
  A0_disable();

  

  return data;
  
}


/** Write data to the display hardware **/

void SED1565DisplayWrite(char data)
{
  SED1565ModeWrite();
  SED1565DataLines(data);
  
 
  // A0=1;E=1;RD_WR=0;
  BATRON_CS_enable();
  RW_WR_enable();

         Nop();Nop();
         Nop();Nop();
         Nop();Nop();
         Nop();Nop();
         Nop();Nop();

  RW_WR_disable();
  BATRON_CS_disable();
  
}


/** Read the display hardware status **/

unsigned char SED1565ReadStatus(void)
{
 unsigned char SED_status;
 // make sure we can read the port pins
 SED1565ModeRead();

 // A0=0;E=0;RW_WR=1
 // A0_enable();       // 0
 // E_RD_enable();     // 0
 // RW_WR_disable();   // 1


 RW_WR_disable();   // 1
 A0_enable();    	// 0
 BATRON_CS_enable();		// 0
 E_RD_enable();     // 0

         Nop();Nop();
         Nop();Nop();
         Nop();Nop();
         Nop();Nop();
         Nop();Nop();

 SED_status = PORTD;
 WriteToEEPROM(SED_status, 0x90);
 WriteToEEPROM(PORTD, 0x91);

 E_RD_disable();    // 1
 BATRON_CS_disable();     // 1
 A0_disable();      // 1

 // return to write mode
 SED1565ModeWrite();

} 

/*unsigned char SED1565ReadData(void)
{
  unsigned char SED_data, SED_hi, SED_lo, dummy;
  unsigned char dummy_rev;

 // make sure we can read the port pins
 SED1565ModeRead();    

 WriteToEEPROM(0xFF, 0x20); 
 WriteToEEPROM(0xFF, 0x21);  
 WriteToEEPROM(0xFF, 0x22); 
 WriteToEEPROM(0xFF, 0x23);  
 WriteToEEPROM(0xFF, 0x50);
 WriteToEEPROM(0xFF, 0x51);
 WriteToEEPROM(0xFF, 0x52);
 WriteToEEPROM(0xFF, 0x53);

// A0=1;E=0;RD_WR=1;
 // A0_disable();      // 1
 // E_RD_enable();    // 0
 // RW_WR_disable();    // 1

 A0_disable();      // 1
 RW_WR_disable();   // 1	
 CS1_enable();		// 0
 E_RD_enable();     // 0
 

 // Data is split over
 //   PORTB[RB7:RB4]
 //   PORTA[RA3:RA0]
 // However each byte received is reversed!

 dummy = (PORTB & 0xF0) | (PORTA & 0x0F); 
 //dummy_rev = (~(PORTB & 0xF0)) & 0xF0 | (~(PORTA & 0x0F)) & 0x0F; 

 WriteToEEPROM(dummy, 0x50);
 WriteToEEPROM(PORTA, 0x51);
 WriteToEEPROM(PORTB, 0x52);
 WriteToEEPROM((PORTB & 0xF0), 0x53);
 WriteToEEPROM((PORTA & 0x0F), 0x54);

 E_RD_disable();     // 1
	Nop();
	Nop();
	Nop();
 E_RD_enable();      // 0

 // Data is split over
 //   PORTB[RB7:RB4]
 //   PORTA[RA3:RA0]
 SED_data = (PORTB & 0xF0) | (PORTA & 0x0F);
 WriteToEEPROM(SED_data, 0x56);
 WriteToEEPROM(PORTA, 0x57);
 WriteToEEPROM(PORTB, 0x58);
 WriteToEEPROM((PORTB & 0xF0), 0x59);
 WriteToEEPROM((PORTA & 0x0F), 0x5A);

 E_RD_disable();    // 1 
 CS1_disable();     // 1
 
 // make sure we can write to the port pins
 SED1565ModeWrite();
 
 return SED_data;
 //return dummy; 
 //return dummy_rev;

}  */



/** Read data from the display hardware **/

unsigned char SED1565ReadData(void)
{
  unsigned char SED_data, dummy;
 
 // make sure we can read the port pins
 SED1565ModeRead();    

// A0=1;E=0;RD_WR=1;
 // A0_disable();      // 1
 // E_RD_enable();    // 0
 // RW_WR_disable();    // 1

 A0_disable();      // 1
 RW_WR_disable();   // 1	
 BATRON_CS_enable();		// 0
 E_RD_enable();     // 0
 

 dummy = PORTD;
 
 E_RD_disable();     // 1
	Nop();
	Nop();
	Nop();
 E_RD_enable();      // 0


 SED_data = PORTD;
 

 E_RD_disable();    // 1 
 BATRON_CS_disable();     // 1
 
 // make sure we can write to the port pins
 SED1565ModeWrite();
 
 return SED_data;
 
}


/** Clear the hardware diplay visible data **/

void SED1565ClearScreen(void)
{
    unsigned char page, col;
    char address, addr;
 	
  for(page=0;page<=8;page++)
	{
	 address = PAGE_ADDRESS_SET | page;				// 0xb0
	 addr = SED1565DataLines(address);
	 SED1565WriteCmd(address);
	   
	 SED1565WriteCmd(COLUMN_ADDRESS_UPPER_SET);		// 0x10
	 SED1565WriteCmd(COLUMN_ADDRESS_LOWER_SET); 	// 0x00
	
	  // The Batron display is actually
	  // 132 pixels wide
   	  for(col=0;col<132;col++)
	    {
             SED1565DisplayWrite(0x00);
	    }
	
   	  }   


}


/** Set a pixel on the display hardware **/

unsigned char SED1565SetPixel(unsigned char x_pos, unsigned char y_pos)
{
   unsigned char x, y, data, temp;

  // make sure we stay in a valid range
  if((x_pos>MAX_X_POS) ||
	 (y_pos>MAX_Y_POS) ||
	 (x_pos<0)         ||
	 (y_pos<0))

	{
	  return 0;
	}
	
   WriteToEEPROM(0xFF, 0x24); 
   WriteToEEPROM(0xFF, 0x25);  
   WriteToEEPROM(0xFF, 0x26);  

	SED1565WriteCmd(PAGE_ADDRESS_SET | x_pos >> 3);
	SED1565WriteCmd(COLUMN_ADDRESS_UPPER_SET | (y_pos & 0xF0)>>4);
	SED1565WriteCmd(COLUMN_ADDRESS_LOWER_SET | (y_pos & 0x0F));

     WriteToEEPROM(x_pos>>3, 0x24);  
	 WriteToEEPROM(x_pos, 0x25); 
     WriteToEEPROM(y_pos, 0x26);  

	data = SED1565ReadData();
    WriteToEEPROM(data, 0x60);

	// set to top row of page
	// extract byte data from x_pos
    WriteToEEPROM(data | x_pos%8, 0x61);

    //SED1565DisplayWrite(data | x_pos%8);
	//SED1565DisplayWrite(data | (8>>(x_pos%8)));
    //SED1565DisplayWrite(data | 1<<(x_pos%8));
	//SED1565DisplayWrite(data | ~(1<<(x_pos%8)));
     SED1565DisplayWrite(1<<(x_pos%8));
	
	return 1;
}	


/** Re-Set a pixel on the display hardware **/

unsigned char SED1565ReSetPixel(unsigned char x_pos, unsigned char y_pos)
{
   unsigned char data;

  // make sure we stay in a valid range
  if((x_pos>MAX_X_POS) ||
	 (y_pos>MAX_Y_POS) ||
	 (x_pos<0)         ||
	 (y_pos<0))

	{
	  return 0;
	}
	
	SED1565WriteCmd(PAGE_ADDRESS_SET | x_pos >> 3);
	SED1565WriteCmd(COLUMN_ADDRESS_UPPER_SET | (y_pos & 0xF0)>>4);
	SED1565WriteCmd(COLUMN_ADDRESS_LOWER_SET | (y_pos & 0x0F));

	data = SED1565ReadData();

	// set to top row of page
	// subtract page address from x_pos

    SED1565DisplayWrite(data & ~(1<<(x_pos%8)));

    // invert the pixels in this byte
	//SED1565DisplayWrite(~(0<<(x_pos%8)));

	return 1;
}



/** Draw a horizontal line on the display **/

void drawlineHorizontal(unsigned char x_pos, unsigned char y_pos, unsigned char length)
{
	int col;

    /* set the start point						
	*  page = x_pos / 8
	*/
	SED1565WriteCmd(PAGE_ADDRESS_SET | x_pos >> 3);
	SED1565WriteCmd(COLUMN_ADDRESS_UPPER_SET | (y_pos & 0xF0)>>4);
	SED1565WriteCmd(COLUMN_ADDRESS_LOWER_SET | (y_pos & 0x0F));
	
	  for(col=0;col<length;col++)
	    {
		 /* Find the correct row
		 *  
		 */
		  SED1565DisplayWrite(0x01 | 1 << (x_pos - ((x_pos>>3))));
   		  //SED1565DisplayWrite(SED1565ReadData(x_pos, y_pos)) | 1 << (x_pos - ((x_pos>>3))));
	    }

}

/** Draw a vertical line on the display **/

void drawlineVertical(unsigned char x_pos, unsigned char y_pos, unsigned char length)	
{
  	unsigned char startpage, endpage, page;
    unsigned char readVal, byteVal;
    char address, addr, i;
	BOOL draw; 	
	
	WriteToEEPROM(0xFF, 0x30); 
 	WriteToEEPROM(0xFF, 0x31);  
	WriteToEEPROM(0xFF, 0x32); 
	WriteToEEPROM(0xFF, 0x33);  
	WriteToEEPROM(0xFF, 0x60);
	WriteToEEPROM(0xFF, 0x61);	

	startpage = x_pos >> 3;   // start page
//	startrow = x_pos%8;	 // row
	endpage = (x_pos + length) >> 3;  // end page
//	endrow = (x_pos + length)%8;
   	
	WriteToEEPROM(x_pos, 0x30); 
 	WriteToEEPROM(x_pos >> 3, 0x31);  
	WriteToEEPROM((x_pos + length)>>3, 0x32); 
 	
	draw = FALSE;
	byteVal = 0xFF;

	
	for(i=0;i<8;i++) // pages
	{
	 page = i;
	 draw = FALSE;

	 WriteToEEPROM(page, 0x60+i);
	  address = PAGE_ADDRESS_SET | page	;
	  addr = SED1565DataLines(address);
	   SED1565WriteCmd(address);	  	

	  SED1565WriteCmd(COLUMN_ADDRESS_UPPER_SET | (y_pos & 0xF0)>>4);
	  SED1565WriteCmd(COLUMN_ADDRESS_LOWER_SET | (y_pos & 0x0F));

	 
	 if(page==startpage)
	  {
		WriteToEEPROM(page, 0x70+i);

		readVal = SED1565ReadData();
		//byteVal = readVal | 0xFF;
		byteVal = 0x50;		

	    WriteToEEPROM(readVal, 0x02);
	    WriteToEEPROM(byteVal, 0x01);
        WriteToEEPROM(readVal & byteVal, 0x00);

	   // byteVal = readVal;

		draw = TRUE;
	  }

 	 if(page==endpage)
	  {
	   WriteToEEPROM(page, 0x80+i);

		byteVal = SED1565ReadData();
		 WriteToEEPROM(byteVal, 0x03);


	    WriteToEEPROM(byteVal, 0x11);
        WriteToEEPROM(page, 0x10);
	    
 		byteVal = 0x05;
		draw = TRUE;
	  }
  	 if((page>startpage)&&(page<endpage))
	  {
		readVal = SED1565ReadData();
		 WriteToEEPROM(byteVal, 0x04+page);
 	  byteVal = 0x55; 
	//	byteVal = 0xFF; 
		draw = TRUE;
	  }

	if(draw==TRUE)
	 {
	  //SED1565DisplayWrite(byteVal);
	  SED1565DisplayWrite(byteVal | SED1565ReadData());
	  draw=FALSE;
	  
	 }
	}
 WriteToEEPROM(i, 0x40);
}

/** Draw an image on the display **/

void drawImage(void)
{
	int address, addr, page, col, i, j;
	char x_pos, y_pos, length;
        char byteVal;

	far rom char *rom_pointer;
	rom_pointer = logo;
	byteVal = *rom_pointer;

    // set page 0
	 page=0;
	 address = PAGE_ADDRESS_SET | page;				// 0xb0
	 addr = SED1565DataLines(address);
	 SED1565WriteCmd(address);
	   
	 SED1565WriteCmd(COLUMN_ADDRESS_UPPER_SET);		// 0x10
	 SED1565WriteCmd(COLUMN_ADDRESS_LOWER_SET); 	// 0x00

	for(i=0;i<=sizeof(logo)/2;i++)
	 {
		byteVal = *(rom_pointer+i);
		SED1565DisplayWrite(byteVal);
	 }

// set page 1
	page = 1;

	 address = PAGE_ADDRESS_SET | page;				// 0xb0
	 addr = SED1565DataLines(address);
	 SED1565WriteCmd(address);
	   
	 SED1565WriteCmd(COLUMN_ADDRESS_UPPER_SET);		// 0x10
	 SED1565WriteCmd(COLUMN_ADDRESS_LOWER_SET); 	// 0x00

	for(i=128;i<=sizeof(logo);i++)
	 {
		byteVal = *(rom_pointer+i);
		SED1565DisplayWrite(byteVal);
	 }

 x_pos = 17;
 y_pos = 0;
 length = 128;
	
	drawlineHorizontal(x_pos, y_pos, length);
	
}


#endif

