#ifndef SED1565_H
#define SED1565_H

/* I N C L U D E S **********************************************************/
#include "GenericTypeDefs.h"

/* D E F I N I T I O N S ****************************************************/
#define	DISPLAY_OFF				0xAE	// 'b10101110'
#define DISPLAY_ON				0xAF	// 'b10101111'
#define ADC_SELECT_NORMAL			0xA0	// 'b10100000'
#define ADC_SELECT_REVERSE			0xA1	// 'b10100001'
#define DISPLAY_NORMAL				0xA6	// 'b10100110'
#define DISPLAY_REVERSE				0xA7	// 'b10100111'
#define DISPLAY_ALL_POINTS_OFF		0xA4	// 'b10100100'
#define DISPLAY_ALL_POINTS_ON 		0xA5	// 'b10100101'
//#define LCD_BIAS_SET				0xA2	// 'b10100010'
#define LCD_BIAS_SET				0xA3	// 'b10100011'
#define READ_MODIFY_WRITE			0xE0	// 'b11100000'
#define	END_READ_MODIFY_WRITE		0xEE	// 'b11101110'
#define RESET						0xE2	// 'b11100010'
#define COMMON_OUTPUT_MODE_NORMAL	0xC0	// 'b11000000'
#define COMMON_OUTPUT_MODE_REVERSED	0xC8	// 'b11001000'
#define POWER_CONROL_MODE			0x2F	// 'b00101111'
#define RESISTOR_RATIO				0x24	// 'b00100110'
//#define RESISTOR_RATIO				0x26	// 'b00100101'
#define ELEC_VOL_MODE_SET			0x81	// 'b10000001'
#define ELEC_VOL_REG_SET			0x2F	// 'b00101111'

#define DISPLAY_START_LINE_SET		0x40	// 'b01 address 0'
#define PAGE_ADDRESS_SET			0xB0	// 'b1011 page address
#define COLUMN_ADDRESS_UPPER_SET	0x10	// upper 4-bits
#define COLUMN_ADDRESS_LOWER_SET	0x00	// lower 4-bits
#define STATIC_INDICATOR_SET		0xAC	// Static Indicator
#define STATIC_INDICATOR			0x02	// blinking 0.5 secs

#define READMODIFYWRITE				0xE0
#define END							0xEE

#define BLANK_CHAR					0x00
#define BLOCK_CHAR					0x0F			

#define SED1565CMD					0x00    // A0=0;E=0;RD_WR=1;
#define SED1565WRITE				0x01	// A0=1;E=1;RD_WR=0;
#define SED1565READ					0x02	// A0=1;E=0;RD_WR=1;
#define SED1565STATUS				0x03	// A0=0;E=0;RW_WR=1

#define MAX_X_POS					63
#define MAX_Y_POS					131


#define DEBUG_TRIG		LATBbits.LATB1
#define TRIG_enable()		LATBbits.LATB1 = 0
#define TRIG_disable()		LATBbits.LATB1 = 1



/* P U B L I C  P R O T O T Y P E S ******************************************/
void SED1565ModeWrite(void);
void SED1565ModeRead(void);
void SED1565HardReset(void);
void SED1565DefaultLines(void);
unsigned char SED1565DataLines(unsigned char);
unsigned char SED1565WriteCmd(char);
void SED1565WriteDisplayData(void);
void SED1565Bootstrap_display(void);
void SED1565ClearScreen(void);
void SED1565DisplayWrite(char);
unsigned char SED1565ReadStatus(void);
unsigned char SED1565SetPixel(unsigned char, unsigned char);
unsigned char SED1565ReSetPixel(unsigned char, unsigned char);
unsigned char SED1565ReadData(void);
void drawlineHorizontal(unsigned char, unsigned char, unsigned char);
void drawlineVertical(unsigned char, unsigned char, unsigned char);	
void drawImage(void);
char setString(ram char*, rom char*);
#endif // SED1565_H
