/** I N C L U D E S **********************************************************/
#include <p18cxxx.h>
#include "system\typedefs.h"
#include "io_cfg.h"
#include "system\CAN\CAN_useHS.h"
#include "system\CAN\CAN2515drv.h"
#include "system\CAN\CAN2515user.h"
#include "user\user.h"
#include "system\CAN\CAN_ProcessMsg.h"

/** V A R I A B L E S ********************************************************/
#pragma udata
extern CAN_USER_FLAGS CAN_UserFlags;
extern CAN_FLAGS CANFlags;
extern CAN2515_REGS CAN2515_regs;
extern CAN_FRAME canFrame;
extern unsigned char *canFrame_ptr;

LRG_MSG largeMessage;
LRG_MSG *largeMessage_ptr;


/** P R O T T Y P E S ********************************************************/

/** D E C L A R A T I O N S *************************************************/
#pragma code

/****************************************************************************/
/* 2515 high level functions												*/
/* Reference document - Microchip Datasheet 210801e							*/
/* Document Title - Stand-Alone CAN Controller with SPI Interface			*/
/* 																			*/
/*	Implements: 															*/
/*			CAN2515_getmode													*/
/*			CAN2515_setmode													*/
/*																			*/
/*    Helper functions:														*/
/*			CAN2515_select													*/
/*			CAN2515_unselect												*/
/*																			*/
/****************************************************************************/

void CAN_ProcessMsg(void)
{
		unsigned char testVal;
		int i = 0;

		// test valid diagnostics messages !!

		if(canFrame.IDENTIFIER == CEM_MSG_RESP)  // 0x72E <- 0x726
		{
		 Nop();
		 if(canFrame.D0 == 0x10)
			 {
			  CAN_flowcontrol();
			   	
			   CANFlags.snd_HSCAN_BUFF = 1;
			   CANFlags.snd_HSCAN = 1;
			
				// Added this AFTER working code
			   canFrame.IDENTIFIER = 0x0000;
			   CANFlags.msg_CAN = 0; 	
		   
			 } 
			
			else if(canFrame.D0 >= 0x20)
				{
				 // capture the Byte(s) of interest  	
				 Nop();
				 largeMessage.ID = canFrame.IDENTIFIER;
				 
				 switch(canFrame.D0)
					{
					// 21 - 29 are largeMessage return bytes
					  
					 case 33:
					  for(i=0; i<canFrame.DLC+1; i++)
		  		        {
						 largeMessage.msg_21[i] =  canFrame_ptr[i+4];
  	      		        }	
					 break;

					 case 34:
					  for(i=0; i<canFrame.DLC+1; i++)
		  		        {
				         largeMessage.msg_22[i] =  canFrame_ptr[i+4];
  	      		        }	

					 break;

					 case 35:
					  for(i=0; i<canFrame.DLC+1; i++)
		  		        {
				         largeMessage.msg_23[i] =  canFrame_ptr[i+4];
  	      		        }	

					 break;

					 case 36:
					  for(i=0; i<canFrame.DLC+1; i++)
		  		        {
				         largeMessage.msg_24[i] =  canFrame_ptr[i+4];
  	      		        }	
		
					 break;

					 case 37:
					  for(i=0; i<canFrame.DLC+1; i++)
		  		        {
				         largeMessage.msg_25[i] =  canFrame_ptr[i+4];
  	      		        }	

					 break;

					 case 38:
					  for(i=0; i<canFrame.DLC+1; i++)
		  		        {
				         largeMessage.msg_26[i] =  canFrame_ptr[i+4];
  	      		        }	

					 break;

					 case 39:
					  for(i=0; i<canFrame.DLC+1; i++)
		  		        {
				         largeMessage.msg_27[i] =  canFrame_ptr[i+4];
  	      		        }	


					 case 40:
					  for(i=0; i<canFrame.DLC+1; i++)
		  		        {
				         largeMessage.msg_28[i] =  canFrame_ptr[i+4];
  	      		        }

					 break;
					
					 case 41:
					  for(i=0; i<canFrame.DLC+1; i++)
		  		        {
				         largeMessage.msg_28[i] =  canFrame_ptr[i+4];
  	      		        }

					 break;
											
					 default:
					 // need to set an error for data overflow
					 break;

					}
			
			
				}

		    	// Enter Diagnostic state response
				else if(canFrame.D1 == 0x50)
					{
					 CAN_UserFlags.diag = canFrame.D2;
					 CANFlags.wait_HSCAN=VIRTUAL_KEY; 
					} 
				
				//ReturnDataByIdentifier
				else if(canFrame.D1 == 0x62)
				  {
					// Act on the relevant data
					word PID = canFrame.D2;
					PID = PID << 8;
					PID = PID + canFrame.D3;

					switch(PID)
						{
						 case 0x412D:
							Nop();						
							//V70_data.rke = canFrame.D4;
	 						break;
						 
						 case 0x411F:
							Nop();						
							//V70_data.key_pos = canFrame.D4;
							CANFlags.wait_HSCAN = RECOVER_RKE_REC;
	 						break; 

 							case 0x4144:
							Nop();						
							//V70_data.rke = canFrame.D1;
							CANFlags.wait_HSCAN = RECOVER_RKE_REC;
	 						break; 
						}

					Nop();
					Nop();
				  }
			
			 
		}	
			
		   // Now check bus messages
			
		   //else if(canFrame.IDENTIFIER == N)	// 0x12A
		   //{
		   //Nop();
		   // V70_data.n = (canFrame.D6 << 4) >> 4 ;
		   // V70_data.n = V70_data.n << 8;
		//	V70_data.n |= canFrame.D7;
		//	Nop();
		//   }


	canFrame.IDENTIFIER = 0x0000;
	CANFlags.msg_CAN = 0;
}