/********************************************************************
 FileName:		CANProcessMsgCAN1.c
 Dependencies:	See INCLUDES section
 Processor:		PIC18 and PIC32 USB Microcontrollers
 Hardware:		This demo is intended to be used on Simbuck Baseboard4550
 				boards supported by the MCHPFSUSB stack.
 Complier:  	Microchip C18 (for PIC18), C32 (for PIC32)
 Company:		Deben Enterprises Ltd



 THIS SOFTWARE IS PROVIDED IN AN ?AS IS? CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************************
 File Description:

 Change History:
  Rev   Description
  ----  -----------------------------------------
  1.0  First release

********************************************************************


/** I N C L U D E S **********************************************************/
#include "simbuck_cfg.h"
#include "../HardwareProfile.h"


#if defined(SIMBUCK_BASEBOARD_4550)
 #include <p18cxxx.h>
 #include "user/user_4550.h"
#endif

#if defined(SIMBUCK_BASEBOARD_PIC32)
 #include <plib.h>
 #include "user/user_32.h"
#endif

#include "GenericTypeDefs.h"
#include "system/CAN/CAN_useCAN1.h"
#include "system/CAN/CAN2515drv.h"
#include "system/CAN/CAN_MsgList.h"
#include "system/CAN/CAN_ProcessMsgCAN1.h"


/** V A R I A B L E S ********************************************************/
#pragma udata
extern CAN_FLAGS CANFlags;
extern CAN_MESSAGES CAN_messages;
extern WORD IDENTIFIER;

LRG_MSG largeMessage;
LRG_MSG *largeMessage_ptr;


/** P R O T T Y P E S ********************************************************/

/** D E C L A R A T I O N S *************************************************/
#pragma code

/****************************************************************************/
/* 2515 high level functions												*/
/****************************************************************************/



void process_CAN_1_bus_msg(void)
{

  if(IDENTIFIER == CAN_messages.BATT_PACK_FRONT_MSG)	// 0x770
   {
     // For the EVBATTMON task we need to pass
     // the data to the 4DSystems display via UART

//     Nop();
//   V70_data.n = (canFrame_CAN_1.D6 << 4) >> 4 ;
//   V70_data.n = V70_data.n << 8;
//   V70_data.n |= canFrame_CAN_1.D7;
     Nop();
   }

 if(IDENTIFIER == CAN_messages.BATT_PACK_REAR_MSG)  // 0x771
  {
    // For the EVBATTMON task we need to pass
    // the data to the 4DSystems display via UART

  //  Nop();
//  V70_data.vs = canFrame_CAN_1.D6;
//  V70_data.vs = V70_data.vs << 8;
//  V70_data.vs |= canFrame_CAN_1.D7;
  // Nop();
 }
		
  
}
