/********************************************************************
 FileName:		e2prom - SpeedBox.h
 Dependencies:	See INCLUDES section
 Processor:		PIC18
 Hardware:		This demo is intended to be used on Simbuck Baseboard4550
 				boards supported by the MCHPFSUSB stack.
 Complier:  	Microchip C18 (for PIC18)
 Company:		Deben Enterprises Ltd



 THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************************
 File Description:

 Change History:
  Rev   Description
  ----  -----------------------------------------
  1.0  First release

********************************************************************/

#ifndef E2PROM_SPEEDBOX_H
#define E2PROM_SPEEDBOX_H

/** I N C L U D E S **********************************************************/


/** E E P R O M   M A P ******************************************************/
// Signals 1&2 have the potential of 15 selectable patterns
// with a record length fixed at 11 bytes of data combining the basic
// 'freqency' with a nominal 'gap' as a datum and is used to offset
// the start point of the 2nd Signal. The 2nd signal is composed of up to
// 8 seperate state changes counted as high/low periods from the baseline
// 'frequency' of Signal 1
// 11 bytes/pattern @ 15 patterns Max = 165 bytes


#define SIG_ONE_START           0x00
#define SIG_TWO_START           0x20

// To implement the full number of patterns with the same 8 state
// changes requires a further:
// 8 changes @ 15 patterns for 2 addditional signals == 240 bytes
// To implement this fully will require additional Hardware!

#define SIG_THREE_START         0x30
#define SIG_FOUR_START          0x40

// modifiers to signal 1 are BIDIRECTION, START_POLARITY 15 Patterns 4 Bytes
#define SIG_ONE_MODIFIER        0x65
// modifiers to all signals are START_POLARITY(Inversion) 15 Patterns 6 Bytes
#define SIG_TWO_MODIFIER        0x66
#define SIG_THREE_MODIFIER      0x67
#define SIG_FOUR_MODIFIER       0x68



#endif

