/* 
 * File:   processSerialPacket.h
 * Author: rjones
 *
 * Created on 18 June 2014, 18:29
 */

#ifndef PROCESSSERIALPACKET_H
#define	PROCESSSERIALPACKET_H

/** I N C L U D E S **********************************************************/



/** D E F I N I T I O N S *****************************************************/

/* Serial Protocol request messages */
#define DEVICE_VERSION          0x10
#define READ_EEPROM             0x14
#define WRITE_EEPROM            0x15
#define GET_BLOCK               0x16


/* self test (Simbuck-JPF) */
#define GET_FUSES               0x20
#define GET_USER_CONFIG         0x21
#define GET_USER_STATUS         0x22
#define GET_PORTS               0x23

/* uC */
#define READ_PORTS              0x3A
#define MONITOR                 0x3B


/* Simbuck RAM */
#define READ_PATTERN            0x5A

/* SW BOOT */
#define RESET_DEVICE            0xFF

/* USB Protocol request data bytes */


/* USB Potocol response messages */
#define SUCCESS                 0xA1
#define POSITIVE_RESPONSE	0xA2
#define NEGATIVE_RESPONSE	0xAD
#define ERROR_RESPONSE		0xAE
#define NOT_SUPPORTED		0xAF

/** P U B L I C  P R O T O T Y P E S ******************************************/
void ProcessSerial(void);


#endif	/* PROCESSSERIALPACKET_H */

