#ifndef USERINITS_H
#define USERINITS_H

/** I N C L U D E S **********************************************************/


/** D E F I N I T I O N S ****************************************************/


/** S T R U C T U R E S ******************************************************/
typedef struct USER_FLAGS
{
    unsigned DEBUG:1;       ///< A Flag to dis-able functionality when testing
    unsigned cpuload:1;     ///< A Flag to estimate load
    unsigned resetCnt:1;    ///< A Flag to enable functionality to test for SW reset
    unsigned slowUpdate:1;  ///< A Flag to trigger slow update of hot Application data structure
    unsigned fastUpdate:1;  ///< A Flag to trigger fast update of hot Application data structure

#if defined(USE_EUSART)
    unsigned SENDUART:1;        ///< A Flag to trigger send bytes function
    unsigned RECVUART:1;        ///< A Flag to trigger receive bytes function
    unsigned RECVBUFF_FULL:1;   ///< A Flag to indicate the receive buffer is full
    unsigned SENDBUFF:1;        ///< A Flag to indicate the send buffer is loaded
#endif

} USER_FLAGS;



/** P U B L I C  P R O T O T Y P E S *****************************************/
void InitStructs(void);



#endif //USERINITS_H
