/*******************************************************************************
 FileName:	user_4550.c
 Dependencies:	See INCLUDES section
 Processor:	PIC18 and PIC32 USB Microcontrollers
 Hardware:      Simbuck Baseboards and PIC32 USB Starter kit
 Complier:  	Microchip C18 (for PIC18), XC32 (for PIC32)
 Company:	Deben Enterprises Limited


 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************************************
 File Description:

 Change History:
  Rev   Description
  ----  -----------------------------------------
  1.0  First release


/** INCLUDES ******************************************************************/
#include "simbuck_cfg.h"
#include "HardwareProfile.h"
#include "system/eeprom/eeprom.h"

#if defined(SIMBUCK_BASEBOARD_4550)
 #include <p18cxxx.h>
#endif


#include "../USB/usb.h"
#include "../USB/usb_function_generic.h"

#include "processUSBpacket.h"
#include "system/interrupt/interrupt.h"
#include "user/user_4550.h"
#include "user/userInits.h"

// TUTORIALS
#include "../tutorials/tut1_helloworld.h"

/** S I M L I B   I N C L U D E S *********************************************/
#if defined(SIMBLOCK_DUAL_CAN)
  #include "HardwareProfile - SimblockDualCAN.h"
  #include "system/spi/simbuckspi.h"
  #include "system/CAN/CAN2515drv.h"
  #include "system/CAN/CAN2515user.h"
  #include "system/CAN/CAN2515utils.h"
  #include "system/CAN/CAN_MsgList.h"

#include "../selftests/selftestDualCAN.h"

#endif

#if defined(SIMBLOCK_ADC)

#endif


/** C O M M O N  V A R I A B L E S ********************************************/
#pragma udata
USER_FLAGS USERFlags;


extern unsigned char bytestosend[];
extern unsigned char bytestoread[];

/** S I M L I B   V A R I A B L E S *******************************************/
#if defined(SIMBLOCK_DUAL_CAN)
extern volatile CAN_FLAGS CANFlags;
extern CAN_PERF CANPerf;

extern unsigned char INPacket[64];
extern unsigned char CAN_1_rcv[14];
char i;

#endif



/** D E C L A R A T I O N S **************************************************/
#pragma code

// called from main from the while(1) loop
// this is where the Users function calls go

int ProcessUser(void)
{
    // User function(s) called from here

    tut1_helloworld();

    #if defined(SIMBLOCK_DUAL_CAN)
      simbuckDualCANSelfTest();
    #endif

 return 0;
}



/** EOF user.c ***************************************************************/
