/*******************************************************************************
 FileName:		user_4685.c
 Dependencies:	        See INCLUDES section
 Processor:		PIC18 ECAN Microcontrollers
 Hardware:		This demo is intended to be used on Simbuck Baseboard4685
 			
 Complier:  	        Microchip C18 (for PIC18)
 Company:		Deben Enterprises Ltd



 THIS SOFTWARE IS PROVIDED IN AN ?AS IS? CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************************************
 File Description:

 Change History:
  Rev   Description
  ----  -----------------------------------------
  1.0  First release

*******************************************************************************/

/** I N C L U D E S ***********************************************************/
#include "simbuck_cfg.h"
#include "HardwareProfile.h"
#include "system/eeprom/eeprom.h"

#if defined(SIMBUCK_BASEBOARD_4685)
 #include <p18cxxx.h>
#endif

#include "../system/serial/simbuckserial.h"
#include "processSerialPacket.h"
#include "system/interrupt/interrupt.h"
#include "user/user_4685.h"
#include "user/userInits.h"

// TUTORIALS
#include "../tutorials/tut1_helloworld.h"


/** S I M L I B   I N C L U D E S *********************************************/
#if defined(SIMBLOCK_ADC)

#endif




/** C O M M O N  V A R I A B L E S ********************************************/
#pragma udata
USER_FLAGS USERFlags;                ///< structure for user semaphore



#if defined(USE_EUSART)
 extern unsigned char *BUFFER_ptr;
 extern unsigned char uartbyte;      ///< data for UART buffer
 extern unsigned char bytestosend[]; ///< buffer for UART data Tx
 extern unsigned char bytestoread[]; ///< buffer for UART data Rx

 int byteCnt;
 
#endif


 #if defined(USE_ECAN)
 extern ECAN_FLAGS ECANFlags;        ///< structure for ECAN semaphore
#endif

/** S I M L I B   V A R I A B L E S *******************************************/
#if defined(SIMBLOCK_STEPDOWN_ADC)
  extern struct ADC_USER ADCUser;
  extern char resetCount;
#endif



/** D E C L A R A T I O N S ***************************************************/
#pragma code

// called from main from the while(1) loop
// this is where the Users function calls go

void ProcessUser(void)
{
    // User function call in here
     tut1_helloworld();

#if defined(USE_EUSART)
     if(USERFlags.SENDUART)
     {
      USERFlags.SENDUART = 0;
      //testcomms();
     }

 /*    if(USERFlags.RECVUART)
     {
      USERFlags.RECVUART = 0;
      

      // byte 2 is the message length
       if(byteCnt == bytestoread[2])
       {
       USERFlags.RECVBUFF_FULL = 1;
       byteCnt = 0;
       }
     }
  */
     if(USERFlags.RECVBUFF_FULL)
     {
      USERFlags.RECVBUFF_FULL = 0;
      // process buffer
      Nop();
      Nop();
       ProcessSerial();
       
     } 

     Nop();

#endif
     
}



/** EOF user.c ***************************************************************/

